#pragma once

#include "_includes.h"

//====================================================
//       :
// https://www.interestprograms.ru
//     
//====================================================

void BlockingSsendRecv(int rank, int count_processes)
{
	int random_number = std::rand();

	if (rank == 0)
	{
		if (count_processes > 1)
		{
			//        .
			int total_sum = 0;

			//       = 0.
			std::cout << "\nRank 0" << " receive number: " << random_number << "\n";

			//          = 0.
			total_sum += random_number;

			//     .
			for (int i = 1; i < count_processes; i++)
			{
				//     .
				int receive_number = -1;

				//     
				//     4
				// if(i < count_processes - 1)
				//   =0       .
				MPI_Recv(&receive_number, 1, MPI_INT, i, MPI_ANY_TAG, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
				
				//      .
				std::cout << "Rank " << i << " receive number: " << receive_number << "\n";

				//    .
				total_sum += receive_number;
			}

			//   .
			std::cout << "Total sum=" << total_sum << "\n";
		}
	}
	else
	{
		//    =0  .
		MPI_Ssend(&random_number, 1, MPI_INT, 0, 0, MPI_COMM_WORLD);

		//   .
		std::cout << "Sent number: " << random_number << "\n";
	}
}